/*
* Personalizzazione per gestione raw click
*/
WebFrame.prototype.Realize = function(parent)
{
  if (this.ChildFrame1 && this.ChildFrame2)
  {
    if (this.Vertical) {
      this.ChildRow1 = document.createElement("div");
      this.ChildRow1.className = "row frame-row";
      //
      this.ChildRow2 = document.createElement("div");
      this.ChildRow2.className = "row frame-row";
      //
      this.ChildBox1 = document.createElement("div");
      this.ChildBox1.setAttribute("id", this.Identifier+":f1");
      this.ChildBox1.className = "col-xs-12 col-sm-12 col-md-12 frame-column frame-vertical-row";
      this.ChildRow1.appendChild(this.ChildBox1);
      //
      this.ChildBox2 = document.createElement("div");
      this.ChildBox2.setAttribute("id", this.Identifier+":f2");
      this.ChildBox2.className = "col-xs-12 col-sm-12 col-md-12 frame-column frame-vertical-row";
      this.ChildRow2.appendChild(this.ChildBox2);
      //
      parent.appendChild(this.ChildRow1);
      parent.appendChild(this.ChildRow2);
    }
    else {
      this.ChildRow = document.createElement("div");
      this.ChildRow.className = "row frame-row";
      //
      this.ChildBox1 = document.createElement("div");
      this.ChildBox1.setAttribute("id", this.Identifier+":f1");
      this.ChildBox1.className = "col-md-6 frame-column";
      this.ChildRow.appendChild(this.ChildBox1);
      //
      this.ChildBox2 = document.createElement("div");
      this.ChildBox2.setAttribute("id", this.Identifier+":f2");
      this.ChildBox2.className = "col-md-6 frame-column";
      this.ChildRow.appendChild(this.ChildBox2);
      //
      parent.appendChild(this.ChildRow);
    }
    //
    // Realizzo i frame secondari
    this.ChildFrame1.Realize(this.ChildBox1);
    this.ChildFrame2.Realize(this.ChildBox2);
    //
    // Mi assegno come padre dei miei figli
    this.ChildFrame1.ParentFrame = this;
    this.ChildFrame2.ParentFrame = this;
    //
    this.Realized = true;
  }
  else
  {
    // Realizzo i miei oggetti visuali
    // Creo il mio contenitore globale
    this.FrameRow = document.createElement("div");
    this.FrameRow.setAttribute("id", this.Identifier);
    this.FrameRow.className = "row frame-row";
    //
    this.FrameCol = document.createElement("div");
    this.FrameCol.className = "col-md-12 frame-column";
    //
    this.FrameBox = document.createElement("div");
    this.FrameBox.setAttribute("id", this.Identifier);
    this.FrameBox.className = "panel panel-default";
    this.FrameBox.className += this.WebForm.ResModeH !== RD3_Glb.FRESMODE_NONE ? " frame-box-fixed" : " frame-box-fluid";
    if (this.Guid)
      this.FrameBox.setAttribute("guid", this.Guid);
    // *****************************************
    this.FrameBox.onclick = function(ev) { this.OnFrameClick(ev, false); }.bind(this);
    this.FrameBox.addEventListener("contextmenu", function(ev) { this.OnFrameClick(ev, false); }.bind(this), true);    
    this.FrameBox.ondblclick = function(ev) { this.OnFrameClick(ev, true); }.bind(this);
    // *****************************************
    //
    // Realizzo la Toolbar
    this.RealizeToolbar();
    //
    this.ContentBox = document.createElement("div");
    this.ContentBox.setAttribute("id", this.Identifier+":cnt");
    this.ContentBox.className = "panel-body collapse in frame-content-box";
     //
    this.FrameBox.appendChild(this.ToolbarBox);
    this.FrameBox.appendChild(this.ContentBox);
    //
    this.FrameCol.appendChild(this.FrameBox);
    this.FrameRow.appendChild(this.FrameCol);
    parent.appendChild(this.FrameRow);
    //
    // Aggancio gli eventi per sentire il collassamento su bootsrap
    var _this = this;
    $(this.ContentBox).on("hidden.bs.collapse", function (ev) {
      // Se hai un gruppo collassabile contenuto in un pannello collassabile quando collassi il gruppo Bootstrap 
      // fa scattare anche questo evento (errore), in quel caso non dobbiamo fare nulla.
      // Lo scopriamo guardando chi ha lanciato l'evento
      if (ev.target !== _this.ContentBox)
        return;
      //
      var eve = new IDEvent("col", _this.Identifier, ev, _this.CollapseEventDef, "col");
      _this.Collapsed = true;
      //
      // Se il ridimensionamento e' NONE basta quello che fa bootstrap, altrimenti
      // devo anche reimpostare la grigliatura tenendo conto della nuova altezza
      if (_this.WebForm.ResModeH !== RD3_Glb.FRESMODE_NONE)
        _this.WebForm.RecalcGridLayout = true;
    });
    $(this.ContentBox).on("shown.bs.collapse", function (ev) {
      var ev = new IDEvent("col", _this.Identifier, ev, _this.CollapseEventDef, "exp");
      _this.Collapsed = false;
      //
      // Se il ridimensionamento e' NONE basta quello che fa bootstrap, altrimenti
      // devo anche reimpostare la grigliatura tenendo conto della nuova altezza
      if (_this.WebForm.ResModeH !== RD3_Glb.FRESMODE_NONE)
        _this.WebForm.RecalcGridLayout = true;
    });
    //
    // Eseguo l'impostazione iniziale delle mie proprieta' (quelle che cambiano l'aspetto visuale)
    this.Realized = true;
    this.SetSmallIcon();
    this.SetCollapsible();
    this.SetCollapsed();
    this.SetLockable();
    this.SetLocked();
    this.SetVisible();
    this.SetEnabled();
    this.SetImage();  
    this.SetCaption();
    this.SetShowToolbar();
    this.SetShowStatusBar();
    this.SetScrollbar();
    this.SetOnlyContent();
    //
    this.SetHeight();
    this.SetMaxHeight();
    this.SetMinHeight();
    //
    this.SetMaxWidth();
    this.SetMinWidth();
    this.SetClassName();
  }
}


IDPanel.prototype.OnFrameClick = function(evento, dbl, btn, x, y, xb, yb, tget)
{
  // calcolo la colonna / riga alla quale e' avvenuto il click
  var row = -1;
  var col = -1;
  //
  if (!tget)
    tget = evento.target?evento.target:evento.srcElement;
  if (!xb)
    xb = evento.clientX;
  if (!yb)
    yb = evento.clientY;
  if (!x) 
    x = xb - RD3_Glb.GetScreenLeft(this.FrameBox);  
  if (!y) 
    y = yb - RD3_Glb.GetScreenTop(this.FrameBox);
  if (!btn) 
    btn = evento.button ? evento.button : 0;
  //
  var id = RD3_Glb.GetRD3ObjectId(tget);
  if (id == undefined)
    return;
  //
  // Ho cliccato su un campo...
  if (id.substr(0,4)=="fld:")
  {
    col = parseInt(id.substr(4),10);
    if (id.indexOf(":fv")>0)
      row = 0;
    if (id.indexOf(":lv")>0)
      row = parseInt(id.substr(id.indexOf(":lv")+3),10);
  }
  //
  var ev = new IDEvent("rawclk", this.Identifier, evento, dbl?this.MouseDoubleClickEventDef:this.MouseClickEventDef, dbl, btn, Math.floor(xb)+"-"+Math.floor(yb), Math.floor(x)+"-"+Math.floor(y), col, null, false, row);
}

/*
* Personalizzazione per gestione raw click
*/